tmepath = os.getenv("TME_PATH_1_3_0")
package.path = package.path .. ";"..tmepath.."/contrib/terrameaddons/?.lua"

local cells = require ("cellspace_functions")

local agts = {}


--[[
	Find out all the values of an attribute of the society
]]
function agts.attrValues (soc, attrname)
	local vs = {}
	forEachAgent (soc, function(agent)
		vs[#vs + 1 ] = agent[attrname]
	end)
return vs
end

--[[
	Places agents in a block of a cellspace 
]]
function agts.placeInBlock (soc, cs, block)
	nagts = soc:size()
	assert (block.xmax > block.xmin)
	assert (block.ymax > block.ymin)
	assert (nagts <= (block.xmax - block.xmin + 1)*( block.ymax - block.ymin + 1), 
            "block not big enough to contain all agents")
	iag = 1
	for i = block.ymin, block.ymax do
		for j = block.xmin, block.xmax do
			agt    = soc:getAgents()[iag]
			cell   = cs:getCell (Coord {x = j, y = i})
			agt:enter (cell)
			if (iag >= nagts) then break end
			iag = iag + 1
		end
	end
end

--[[
	Places agents randomly in empty cells
]]
function agts.placeRandomly (soc, cs)
	forEachAgent (soc, function (agent)
			agent:enter(cells.findEmpty (cs))
	end)
end

--[[  
	Color the social Network -- used to see the agents
]]
function agts.colorSocialNetworks (soc, cs, color)
	assert (cs ~= nil, "colorSocialNetwork: no cell space" )
	forEachCell (cs, function (cell) cell.socialNetwork = 0 end)

	forEachAgent (soc, function (agent)
		for k,other in pairs(agent.sn.connections) do
			agts.colorPath (cs, agent, other, color)
		end
	end)
end

--[[  
	Color a path between two agents
]]
function agts.colorPath (cs, ag1, ag2, color)
	assert (ag1:getCell() ~= nil, "colorPath: agent1 is not placed in the cell space")
	assert (ag2:getCell() ~= nil, "colorPath: agent2 is not placed in the cell space")
	c1 = ag1:getCell()
	c2 = ag2:getCell()
	path = cells.findPath (c1, c2) 
	for k,v in pairs (path) do
		cs:getCell(v).socialNetwork = color
	end
end

function agts.randomWalk (soc)
	forEachAgent(soc, function(ag)
				ag:randomWalk()
		end)
end

function agts.count (soc)
    count = 0
	forEachAgent(soc, function(ag)
				count = count + 1
		end)
    return count
end
return agts